var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
import { expect, } from "chai";
import { it, describe, } from "mocha";
import Vue from "vue";
import Component from "vue-class-component";
import { getTestGql, NORMALIZED_OPTIONS, } from "./test/utils";
import SmartQuery from "./SmartQuery";
describe("./SmartQuery", function () {
    describe("SmartQuery()", function () {
        it("use with gql", function () {
            var gql = getTestGql();
            var TestSmartQueryWithGql = /** @class */ (function (_super) {
                __extends(TestSmartQueryWithGql, _super);
                function TestSmartQueryWithGql() {
                    return _super !== null && _super.apply(this, arguments) || this;
                }
                __decorate([
                    SmartQuery(gql)
                ], TestSmartQueryWithGql.prototype, "test", void 0);
                TestSmartQueryWithGql = __decorate([
                    Component
                ], TestSmartQueryWithGql);
                return TestSmartQueryWithGql;
            }(Vue));
            expect(new TestSmartQueryWithGql().$options.apollo).to.deep.equal({
                test: __assign(__assign({}, NORMALIZED_OPTIONS), { query: gql }),
            });
        });
        it("use with object", function () {
            var gql = getTestGql();
            var TestSmartQueryWithObject = /** @class */ (function (_super) {
                __extends(TestSmartQueryWithObject, _super);
                function TestSmartQueryWithObject() {
                    return _super !== null && _super.apply(this, arguments) || this;
                }
                __decorate([
                    SmartQuery({
                        query: gql,
                        subscribeToMore: {},
                    })
                ], TestSmartQueryWithObject.prototype, "test", void 0);
                TestSmartQueryWithObject = __decorate([
                    Component
                ], TestSmartQueryWithObject);
                return TestSmartQueryWithObject;
            }(Vue));
            expect(new TestSmartQueryWithObject().$options.apollo).to.deep.equal({
                test: __assign(__assign({}, NORMALIZED_OPTIONS), { query: gql, subscribeToMore: [
                        {},
                    ] }),
            });
        });
    });
});
//# sourceMappingURL=SmartQuery.test.js.map