(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('vue-class-component'), require('lodash')) :
    typeof define === 'function' && define.amd ? define(['exports', 'vue-class-component', 'lodash'], factory) :
    (global = global || self, factory(global.VueApolloDecorators = {}, global.VueClassComponent, global._));
}(this, (function (exports, vueClassComponent, lodash) { 'use strict';

    function isDocumentNode(value) {
        return lodash.isObject(value) && value.kind === "Document";
    }
    function normalizeOptions(options) {
        if (options === void 0) { options = {}; }
        var query = isDocumentNode(options) ? {
            query: options,
        } : options;
        query.subscribeToMore = lodash.concat([], isDocumentNode(options) ? [] : options.subscribeToMore || []);
        return query;
    }
    function mergeOptions(original, options) {
        return lodash.mergeWith(normalizeOptions(original), normalizeOptions(options), function (origVal, option) {
            if (lodash.isArray(origVal))
                return lodash.concat(origVal, option);
        });
    }

    function SmartQuery(options) {
        return vueClassComponent.createDecorator(function (componentOptions, key) {
            var apollo = componentOptions.apollo = componentOptions.apollo || {};
            apollo[key] = mergeOptions(apollo[key], options);
        });
    }

    function SubscribeToMore(options) {
        return vueClassComponent.createDecorator(function (componentOptions, key) {
            var apollo = componentOptions.apollo = componentOptions.apollo || {};
            apollo[key] = mergeOptions(apollo[key], {
                subscribeToMore: options,
            });
        });
    }

    exports.SmartQuery = SmartQuery;
    exports.SubscribeToMore = SubscribeToMore;

    Object.defineProperty(exports, '__esModule', { value: true });

})));
//# sourceMappingURL=index.umd.js.map
