import { concat, isArray, isObject, mergeWith, } from "lodash";
export function isDocumentNode(value) {
    return isObject(value) && value.kind === "Document";
}
export function normalizeOptions(options) {
    if (options === void 0) { options = {}; }
    var query = isDocumentNode(options) ? {
        query: options,
    } : options;
    query.subscribeToMore = concat([], isDocumentNode(options) ? [] : options.subscribeToMore || []);
    return query;
}
export function mergeOptions(original, options) {
    return mergeWith(normalizeOptions(original), normalizeOptions(options), function (origVal, option) {
        if (isArray(origVal))
            return concat(origVal, option);
    });
}
//# sourceMappingURL=utils.js.map